<?php
/*
Plugin Name: LJ Custom Menu Links
Plugin URI: http://www.thelazysysadmin.net/software/wordpress-plugins/lj-custom-menu-links/
Description: LJ Custom Menu Links can be used to display custom links in your Wordpress Menu
Author: Jon Smith
Version: 1.2
Author URI: http://www.thelazysysadmin.net/
*/

class LJCustomMenuLinks {

  function LJCustomMenuLinks() {
    add_filter( 'wp_list_pages', array( &$this, 'wp_list_pages' ) );

    // admin menu
    add_action( 'admin_menu', array(&$this, 'admin_menu') );
  }

  function admin_menu() {
    if ( function_exists('add_options_page') )
      add_options_page(__('LJ Custom Menu Links Configuration'), __('LJ Custom Menu Links'), 8, __FILE__, array(&$this, 'config'));
  }

  function config() {
    $options = get_option('LJCustomMenuLinks');

    if ($options === false) {
      $options = array();
    }

    $defaults = array
    (
      'enabled' => true,
      'nextid' => 1,
      'showlogout' => true
    );

    foreach ($defaults as $key => $value) {
      if (!isset ($options[$key]))
        $options[$key] = $value;
    }

    if (isset($options['links'])) {
      uasort($options['links'], array(&$this, 'sort_links'));
    }

    $action = isset($_REQUEST['action']) ? $_REQUEST['action'] : '';
    $link_id = isset($_GET['link_id']) ? $_GET['link_id'] : -1;

?>
<div class='wrap'>
<?php  
  $displaymain = true;
  switch ($action) {
    case 'edit':
      $displaymain = false;
?>
  <h2>LJ Custom Menu Links | Edit Link</h2>
<div class="clear"></div>

<form action="" method="post" id="LJCustomMenuLinksEditForm" accept-charset="utf-8">
  <input type="hidden" name="action" value="editproc" />
  <input type="hidden" name="link_id" value="<?php echo $link_id; ?>" />
  <?php wp_nonce_field('LJCustomMenuLinks-edit'); ?>
  <table class="form-table">
      <tr class="form-field form-required">
        <th scope="row" valign="top"><label for="linktext">Link Text</label></th>
                                    
        <td><input name="linktext" id="linktext" type="text" value="<?php echo $options['links'][$link_id]['text']; ?>" size="40" aria-required="true" /><br />
              <span class="description">The anchor text that is display for the link.</span></td>
      </tr>
      <tr class="form-field">
        <th scope="row" valign="top"><label for="linkurl">URL</label></th>
        <td><input name="linkurl" id="linkurl" type="text" value="<?php echo $options['links'][$link_id]['url']; ?>" size="40" /><br />
              <span class="description">The URL of the link ie. 'http://www.google.com.au'.</span></td>

      </tr>
      <tr class="form-field">
        <th scope="row" valign="top"><label for="linktarget">Target</label></th>
        <td>
            <select name='linktarget' id='linktarget' class='postform' >
    <option value="_blank" <?php if ($options['links'][$link_id]['target'] == '_blank') echo "selected='selected'"; ?>>New Blank Window</option>
    <option class="level-0" value="_self" <?php if ($options['links'][$link_id]['target'] == '_self') echo "selected='selected'"; ?>>Open Link In Current Window</option>
  </select>
  <br />

                  <span class="description">Defines the behaviour of the link, choose to open a new window or stay in the current window.</span>
          </td>
      </tr>
  <tr valign="top">
  <th scope="row">Display Link</th>
  <td><fieldset><legend class="screen-reader-text"><span>Display Link</span></legend>
  <label for="linkdisplay">
  <input name="linkdisplay" type="checkbox" id="linkdisplay" value="1" <?php if ($options['links'][$link_id]['display'] == true) echo "checked='checked'"; ?> />
  Display the link in the menu.</label><br />
  </fieldset></td>
  </tr>
  <tr valign="top">
  <th scope="row">Only Logged In</th>
  <td><fieldset><legend class="screen-reader-text"><span>Only Logged In</span></legend>
  <label for="linkonlyloggedin">
  <input name="linkonlyloggedin" type="checkbox" id="linkonlyloggedin" value="1" <?php if ($options['links'][$link_id]['only_logged_in'] == true) echo "checked='checked'"; ?> />
  Use this setting to display the link only if a user is logged in.</label><br />
  </fieldset></td>
  </tr>
      <tr class="form-field">
        <th scope="row" valign="top"><label for="linksortorder">Sort Order</label></th>
        <td><input name="linksortorder" id="linksortorder" type="text" value="<?php echo $options['links'][$link_id]['sort_order']; ?>" size="40" /><br />
              <span class="description">The text entered here will be used to sort the links, can be a number or text.</span></td>

      </tr>

        </table>
  <p class="submit"><input type="submit" class="button-primary" name="submit" value="Update Link" /></p>
</form>
<?php
      break;
    case "editproc":
      check_admin_referer('LJCustomMenuLinks-edit');
      
      $link_id = $_REQUEST['link_id'];
      $link_text = $_REQUEST['linktext'];
      $link_url = $_REQUEST['linkurl'];
      $link_target = $_REQUEST['linktarget'];
      $link_display = isset($_REQUEST['linkdisplay']) ? $_REQUEST['linkdisplay'] : 0;
      $link_onlyloggedin = isset($_REQUEST['linkonlyloggedin']) ? $_REQUEST['linkonlyloggedin'] : 0;
      $link_sortorder = $_REQUEST['linksortorder'];
      
      $options['links'][$link_id]['text'] = $link_text;
      $options['links'][$link_id]['url'] = $link_url;
      $options['links'][$link_id]['target'] = $link_target;
      $options['links'][$link_id]['display'] = ($link_display == 1) ? true : false;
      $options['links'][$link_id]['only_logged_in'] = ($link_onlyloggedin == 1) ? true : false;
      $options['links'][$link_id]['sort_order'] = $link_sortorder;
      
      break;  
    case "delete":
      $nonce = isset($_REQUEST['_wpnonce']) ? $_REQUEST['_wpnonce'] : '';

      if (!wp_verify_nonce($nonce, 'LJCustomMenuLinks-delete') ) die('Security check');
      
      $link_id = isset($_REQUEST['link_id']) ? $_REQUEST['link_id'] : -1;
      
      unset($options['links'][$link_id]);
    
      break;
    case "add":
      $displaymain = false;
?>
  <h2>LJ Custom Menu Links | Add Link</h2>
<div class="clear"></div>

<form action="" method="post" id="LJCustomMenuLinksAddForm" accept-charset="utf-8">
  <input type="hidden" name="action" value="addproc" />
  <?php wp_nonce_field('LJCustomMenuLinks-add'); ?>
  <table class="form-table">
      <tr class="form-field form-required">
        <th scope="row" valign="top"><label for="linktext">Link Text</label></th>
                                    
        <td><input name="linktext" id="linktext" type="text" size="40" aria-required="true" /><br />
              <span class="description">The anchor text that is display for the link.</span></td>
      </tr>
      <tr class="form-field">
        <th scope="row" valign="top"><label for="linkurl">URL</label></th>
        <td><input name="linkurl" id="linkurl" type="text" size="40" /><br />
              <span class="description">The URL of the link ie. 'http://www.google.com.au'.</span></td>

      </tr>
      <tr class="form-field">
        <th scope="row" valign="top"><label for="linktarget">Target</label></th>
        <td>
            <select name='linktarget' id='linktarget' class='postform' >
    <option value="_blank" selected="selected">New Blank Window</option>
    <option class="level-0" value="_self">Open Link In Current Window</option>
  </select>
  <br />
                  <span class="description">Defines the behaviour of the link, choose to open a new window or stay in the current window.</span>
          </td>
      </tr>
  <tr valign="top">
  <th scope="row">Display Link</th>
  <td><fieldset><legend class="screen-reader-text"><span>Display Link</span></legend>
  <label for="linkdisplay">
  <input name="linkdisplay" type="checkbox" id="linkdisplay" value="1" />
  Display the link in the menu.</label><br />
  </fieldset></td>
  </tr>
  <tr valign="top">
  <th scope="row">Only Logged In</th>
  <td><fieldset><legend class="screen-reader-text"><span>Only Logged In</span></legend>
  <label for="linkonlyloggedin">
  <input name="linkonlyloggedin" type="checkbox" id="linkonlyloggedin" value="1" />
  Use this setting to display the link only if a user is logged in.</label><br />
  </fieldset></td>
  </tr>
      <tr class="form-field">
        <th scope="row" valign="top"><label for="linksortorder">Sort Order</label></th>
        <td><input name="linksortorder" id="linksortorder" type="text" size="40" /><br />
              <span class="description">The text entered here will be used to sort the links, can be a number or text.</span></td>

      </tr>

        </table>
  <p class="submit"><input type="submit" class="button-primary" name="submit" value="Add Link" /></p>
</form>
<?php
    
      break;  
    case "addproc":
      check_admin_referer('LJCustomMenuLinks-add');
      
      $link_text = $_REQUEST['linktext'];
      $link_url = $_REQUEST['linkurl'];
      $link_target = $_REQUEST['linktarget'];
      $link_display = isset($_REQUEST['linkdisplay']) ? $_REQUEST['linkdisplay'] : 0;
      $link_onlyloggedin = isset($_REQUEST['linkonlyloggedin']) ? $_REQUEST['linkonlyloggedin'] : 0;
      $link_sortorder = $_REQUEST['linksortorder'];
      
      $options['links'][$options['nextid']]['id'] = $options['nextid'];
      $options['links'][$options['nextid']]['text'] = $link_text;
      $options['links'][$options['nextid']]['url'] = $link_url;
      $options['links'][$options['nextid']]['target'] = $link_target;
      $options['links'][$options['nextid']]['display'] = ($link_display == 1) ? true : false;
      $options['links'][$options['nextid']]['only_logged_in'] = ($link_onlyloggedin == 1) ? true : false;
      $options['links'][$options['nextid']]['sort_order'] = $link_sortorder;
      $options['nextid']++;
      
      break;
    case "editsettings":
      check_admin_referer('LJCustomMenuLinks-editsettings');

      $links_enabled = isset($_REQUEST['linksenabled']) ? $_REQUEST['linksenabled'] : 0;
      $links_logoff = isset($_REQUEST['linkslogoff']) ? $_REQUEST['linkslogoff'] : 0;
      
      $options['enabled'] = ($links_enabled == 1) ? true : false;
      $options['showlogout'] = ($links_logoff == 1) ? true : false;
      
      break;
  }

  if ($displaymain) {
?>
  <h2>LJ Custom Menu Links</h2>
    <h3>Settings</h3>
<div class="clear"></div>

<form action="" method="post" id="LJCustomMenuLinksEditForm" accept-charset="utf-8">
  <input type="hidden" name="action" value="editsettings" />
  <?php wp_nonce_field('LJCustomMenuLinks-editsettings'); ?>
  <table class="form-table">
  <tr valign="top">
  <th scope="row">LJ Custom Menu Links Enabled</th>
  <td><fieldset><legend class="screen-reader-text"><span>LJ Custom Menu Links Enabled</span></legend>
  <label for="linksenabled">
  <input name="linksenabled" type="checkbox" id="linksenabled" value="1" <?php if ($options['enabled'] == true) echo "checked='checked'"; ?> />
  Uncheck to disable LJ Custom Menu Links.</label><br />
  </fieldset></td>
  </tr>
  <tr valign="top">
  <th scope="row">Display Logoff</th>
  <td><fieldset><legend class="screen-reader-text"><span>Display Logoff</span></legend>
  <label for="linkslogoff">
  <input name="linkslogoff" type="checkbox" id="linkslogoff" value="1" <?php if ($options['showlogout'] == true) echo "checked='checked'"; ?> />
  Check this to display a Logoff button if a user is logged in.</label><br />
  </fieldset></td>
  </tr>
        </table>
  <p class="submit"><input type="submit" class="button-primary" name="submit" value="Update Settings" /></p>
</form>
    <h3>Links</h3>
<div class="clear"></div>
<table class="widefat tag fixed" cellspacing="0">
  <thead>
  <tr>
  <th scope="col" id="text" class="manage-column column-text" style="">Text</th>
  <th scope="col" id="url" class="manage-column column-url" style="">URL</th>
  <th scope="col" id="target" class="manage-column column-target" style="">Target</th>
  <th scope="col" id="display" class="manage-column column-display" style="">Display</th>
  <th scope="col" id="only_logged_in" class="manage-column column-only_logged_in" style="">Only Logged In</th>
  <th scope="col" id="sort_order" class="manage-column column-sortorder" style="">Sort Order</th>
  </tr>
  </thead>

  <tfoot>
  <tr>
  <th scope="col" id="text" class="manage-column column-text" style="">Text</th>
  <th scope="col" id="url" class="manage-column column-url" style="">URL</th>
  <th scope="col" id="target" class="manage-column column-target" style="">Target</th>
  <th scope="col" id="display" class="manage-column column-display" style="">Display</th>
  <th scope="col" id="only_logged_in" class="manage-column column-only_logged_in" style="">Only Logged In</th>
  <th scope="col" id="sort_order" class="manage-column column-sortorder" style="">Sort Order</th>
  </tr>
  </tfoot>

  <tbody id="the-list" class="list:tag">
<?php
  $i = 0;
  
  if (isset($options['links'])) {
    foreach ($options['links'] as $link) {
?>
  <tr id="tag-<?php echo $link['id']; ?>" class="iedit<?php if (($i % 2) == 0) echo " alternate"; ?>">
    <td class="text column-text"><?php echo $link['text']; ?>
      <div class="row-actions"><span class='edit'><a href="options-general.php?page=lj-custom-menu-links/lj-custom-menu-links.php&amp;action=edit&amp;link_id=<?php echo $link['id']; ?>">Edit</a> | </span><span class='delete'><a class='delete:the-list:tag-3 submitdelete' href='options-general.php?page=lj-custom-menu-links/lj-custom-menu-links.php&amp;action=delete&amp;link_id=<?php echo $link['id']; ?>&amp;_wpnonce=<?php echo wp_create_nonce('LJCustomMenuLinks-delete'); ?>' onclick="return confirm('Are you sure you want to delete this link?');">Delete</a></span></div></td>
    <td class="url column-url"><?php echo $link['url']; ?></td>
    <td class="target column-target"><?php echo $link['target']; ?></td>
    <td class="display column-display"><?php if ($link['display']) { echo "True"; } else { echo "False"; } ?></td>
    <td class="only_logged_in column-only_logged_in"><?php if ($link['only_logged_in']) { echo "True"; } else { echo "False"; } ?></td>
    <td class="sort_order column-sort_order"><?php echo $link['sort_order']; ?></td>
  </tr>
<?php
      $i++;
    }
  }  
?>
</tbody>

</table>

<p class="submit"><input type="button" class="button-primary" name="add" value="Add Link" onclick="window.location.href='options-general.php?page=lj-custom-menu-links/lj-custom-menu-links.php&amp;action=add'" /></p>

<?php
  }
  
  update_option('LJCustomMenuLinks', $options);

?>
</div>
<?php  

  }

  function wp_list_pages($html) {
    $options = get_option('LJCustomMenuLinks');

    if ($options === false) {
      $options = array();
    }

    $defaults = array
    (
      'enabled' => true,
      'nextid' => 1,
      'showlogout' => true
    );

    foreach ($defaults as $key => $value) {
      if (!isset ($options[$key]))
        $options[$key] = $value;
    }

    if (isset($options['links'])) {
      uasort($options['links'], array(&$this, 'sort_links'));
    }

    if (isset($options['links']) && $options['enabled']) {
      foreach ($options['links'] as $link) {
        if ($link['display'] && (is_user_logged_in() || !$link['only_logged_in'])) {
          $html .= '<li class="page_item"><a href="'.$link['url'].'" title="'.$link['text'].'" target="'.$link['target'].'">'.$link['text'].'</a></li>';
        }
      }
    }

    if (isset($options['showlogout']) && $options['showlogout'] && is_user_logged_in() && $options['enabled']) {
      $html .= '<li class="page_item"><a href="'.wp_logout_url(site_url()).'" title="Logout">Logout</a></li>';
    }

    return $html;
  }

  function sort_links($a, $b) {
    return strcmp($a['sort_order'], $b['sort_order']);
  }

}

$LJCustomMenuLinks = new LJCustomMenuLinks();

?>